/*C**************************************************************************
* $RCSfile: flash_lib.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $
* :			$Revision: 1.6 $
* FILE_CVSID:	$Id: flash_lib.c,v 1.6 2003/10/02 15:05:27 jberthy Exp $
*----------------------------------------------------------------------------
* ړI:
* ̧قAVRpׯ ײނ܂݂܂B
*****************************************************************************/

/*_____ ݸٰ ____________________________________________________________*/
#include "config.h"
#include "flash_lib.h"
#include "flash_drv.h"

#ifndef FLASH_SIZE
#error config.hɉ޲ĂFLASH_SIZE`Ȃ΂Ȃ܂B
#endif

#ifdef DEBUG_FLASHWR
Uchar debug_buffer[FLASH_PAGE_SIZE];
  void debug_flash_fill_temp_buffer(Uint16 data16, Uint32 addr)
  {
	*(Uint16*)&debug_buffer[LOW(addr)%FLASH_PAGE_SIZE] = data16;
  }

#endif

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

/*_____ 錾 _______________________________________________________________*/

/*F**************************************************************************
* O: flash_wr_byte
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void flash_wr_byte(Uint32 addr_byte, Uchar value)
{
  Enable_flash();
  flash_wr_block(&value, addr_byte, 1);
  Disable_flash();
}

/*F**************************************************************************
* O: flash_wr_block
*----------------------------------------------------------------------------
* Ұ:
* ߂l:
*----------------------------------------------------------------------------
* ړI: ̊֐ߏׯ ؂256޲Ă܂ł݂̏܂B
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* : ̊֐gpɂ́Å֐ꐮǗȂ߁A޲Đ
*	  łȂ΂Ȃ܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
Uchar flash_wr_block(Byte _MemType_* src, Uint32 dst, Uchar n)
{
  Uint16 nb_byte, temp16,temp1,temp2;
  Uint32 address, dst_save;;

  if (!n) return (TRUE);
  Enable_flash();
  do
  {
	dst_save = dst;
	if ((dst%FLASH_PAGE_SIZE)==0)								//-- Jnڽ߰ސȂA
	{
	  for (nb_byte=0; (nb_byte<n)&&(nb_byte<FLASH_PAGE_SIZE)&&((nb_byte+2)<=n); nb_byte+=2,src+=2,dst+=2)
	  {
		flash_fill_temp_buffer(htons(*(Uint16 *)src),dst);		// ްŊɏՕ𖞂B
	  }
	  address=dst;

	  if (n&0x01)												// ŏI޲ĂꐮłȂ΁A
	  {
		temp1 = (*(Uchar*)src)<<8;
		temp2 = flash_rd_byte((Uchar __FLASHTYPE*)(address+1));
		temp16= temp1+temp2;
		flash_fill_temp_buffer(temp16, dst);
		nb_byte+=2;
		address+=2;
		src++;
	  }

	  if (n>nb_byte)
	  {
		n-=nb_byte;
	  }
	  else
	  {n = 0;}

	  for (; nb_byte<FLASH_PAGE_SIZE; nb_byte+=2,address+=2)	// ׯǂްŊɏՕ𖞂B
	  {
		flash_fill_temp_buffer(flash_rd_word((Uint16 __FLASHTYPE*)address),address);
	  }
	  Flash_page_erase(dst_save);
	  Flash_page_write(dst_save);

	}else{														// Jnڽ߰ސ񂵂ĂȂ΁A

	  nb_byte = LOW(dst)%FLASH_PAGE_SIZE;
	  address = dst-nb_byte;
	  for (nb_byte =0; nb_byte<(LOW(dst)%FLASH_PAGE_SIZE)&&((nb_byte+2)<= LOW(dst));nb_byte+=2, address+=2)	// ׯǂްŊɏՕ𖞂B
	  {
		flash_fill_temp_buffer(flash_rd_word((Uint16 __FLASHTYPE*)address),address);
	  }

	  if (LOW(dst)&0x01)										// 擪޲ĂŐ񂵂ĂȂ΁A
	  {
		temp16 = flash_rd_byte((Uchar __FLASHTYPE*)address)<<8;
		temp16 |= *(Uchar*) (src);
		flash_fill_temp_buffer(temp16, address);
		nb_byte+=2;
		address+=2;
		src++;
	  }

	  temp16 = nb_byte;

	  for (; (nb_byte<(LOW(dst)+n))&&(nb_byte<FLASH_PAGE_SIZE)&&((nb_byte+2)<=(LOW(dst)+n));nb_byte+=2,src+=2,address+=2)	// ްŊɏՕ𖞂B
	  {
		flash_fill_temp_buffer(htons(*(Uint16 *)src),address);
	  }
	  if (nb_byte < FLASH_PAGE_SIZE)
	  {
		if (((LOW(dst)&0x01)&&!(n&0x01))||(!(LOW(dst)&0x01)&&(n&0x01)))		// ŏI޲ĂꐮłȂ΁A
		{
		  temp16 = *(Uchar*) (src)<<8;
		  temp16 |= flash_rd_byte((Uchar __FLASHTYPE*)address+1);
		  flash_fill_temp_buffer(temp16, address);
		  address+=2;
		  nb_byte+=2;
		}
	  }
	  if (n>nb_byte)
	  {
		n-=nb_byte;
	  }
	  else if (nb_byte==FLASH_PAGE_SIZE)	// 㑤ۏ
	  {
		if ((nb_byte%dst)>n){ n =0;}
		else                {n -=(nb_byte%dst);}
		dst +=(nb_byte%dst);
	  }else
	  {n = 0;}

	  for (; nb_byte<FLASH_PAGE_SIZE; nb_byte+=2,address+=2)	// ׯǂްŊɏՕ𖞂B
	  {
		flash_fill_temp_buffer(flash_rd_word((Uint16 __FLASHTYPE*)address),address);
	  }

	  Flash_page_erase(dst_save);
	  Flash_page_write(dst_save);
	}
  }while(n);
  Disable_flash();
  return TRUE;
}

/****************************************************************************
* O: flash_erase
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void flash_erase(void)
{
#if FLASH_SIZE > 0
  Uint32 nb_page;

  Enable_flash();
  nb_page=0;
  do {
	Flash_page_erase(nb_page);
	nb_page += FLASH_PAGE_SIZE;
  } while (nb_page<(FLASH_SIZE-BOOT_SIZE));
  Flash_RWW_Read_enable();
  Disable_flash();
#endif
}

/****************************************************************************
* O: flash_rd_byte
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
Uchar flash_rd_byte(Uchar __FLASHTYPE* addr)
{
  unsigned char temp;

  Enable_flash();
  temp = *addr;
  Disable_flash();
  return temp;
}
/****************************************************************************
* O: flash_rd_word
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
Uint16 flash_rd_word(Uint16 __FLASHTYPE* addr)
{
  Union16 temp;

  Enable_flash();
  temp.b[1] = flash_rd_byte ((Uchar __FLASHTYPE*) addr);
  temp.b[0] = flash_rd_byte ((Uchar __FLASHTYPE*)addr+1)
  Disable_flash();
  return temp.w;
}
