/*C**************************************************************************
* $RCSfile: uart_lib.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $
* :			$Revision: 1.20 $
* FILE_CVSID:	$Id: uart_lib.c,v 1.20 2003/08/29 12:45:13 jberthy Exp $
*----------------------------------------------------------------------------
* ړI:
* ̧قUARTʂŏVT100[ƓƎI/OxƂ̌݊񋟂܂B
*****************************************************************************/

/*_____ ݸٰ ____________________________________________________________*/
#include "config.h"
#include "uart_lib.h"

/*_____ S̒` ___________________________________________________________*/
/*V**************************************************************************
* O: uart_hit
*----------------------------------------------------------------------------
* ړI:
* RIׯ: MĂ܂B
*****************************************************************************/
volatile bit uart_hit;

#ifdef LOGO_ATMEL
/*V**************************************************************************
* O: txt_logo_atmel
*----------------------------------------------------------------------------
* ړI:
* Wۺޕɂ̕޲Ăǉ
* LOGO_ATMEL`Ăꍇ: ATMELۺނASCIIG+J
* Ȃ: J
*----------------------------------------------------------------------------
* :
* `ׂCODE_MEM(؈ʒuʎq)
*****************************************************************************/
char _ConstType_ txt_logo_atmel[]="\n\
        _____________________________\n\
      /___   ________________________|\n\
     ___  | |  ________    ____   _\n\
    /   | | | |  _   _ \\  |  __| | |\n\
   / /| | | | | | | | | | | |__  | |\n\
  / / | | | | | | | | | | |  __| | |\n\
 / /_ | | | | | | | | | | | |__  | |__\n\
/____||_| |_| |_| |_| |_| |____| |___/\n\
 ___________________________________\n\
|__________________________________/ (R)\n\
$Name: can11-bl-uart-can-0_0_8 $\n\n";
#else
char _ConstType_ txt_logo_atmel[]="Atmel (R)\n$Name: can11-bl-uart-can-0_0_8 $\n\n";
#endif

/*_____ ` _______________________________________________________________*/

/*_____ ϸ ________________________________________________________________*/
#ifndef UART_MINIMUM
/*F**************************************************************************
* O: uart_puts
*----------------------------------------------------------------------------
* Ұ:
*		sz: UARTɏo͂0I[
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* UARTɕo
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
* ̊֐VT100`ԂōœKuart_splashuart_clrscrɒǉ܂
* (ޗʌ)B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void uart_puts (char _GenericType_ * sz)
{
register char   ch;

for (;ch=*sz++;)
  {
	if (ch=='\n') uart_putchar('\r');
	uart_putchar(ch);
  }
  uart_putchar('\r');
  uart_putchar('\n');
}

/*F**************************************************************************
* O: uart_clrscr
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* VT100[(ʏ)
*----------------------------------------------------------------------------
* :
* uart_clrsscr(); // CLS
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void uart_clrscr (void)
{
#ifndef DISABLE_VT100
  char _ConstType_   sz_init[]="\033c\033\133?25l";		// \033c=\033(2j=ʏ, \133?25l=قȂ
  uart_puts(sz_init);
#else	// 25VKs
  uart_gotoxy(1,25);
#endif
}

#ifdef ENABLE_SPLASH_SCREEN
  bit state_uart_splash=0;

/*F**************************************************************************
* O: uart_splash
*----------------------------------------------------------------------------
* Ұ:
* ߂l: IȂTRUE
*----------------------------------------------------------------------------
* ړI:
* ۺމ
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
bit uart_splash (void)
{
  if (!state_uart_splash)
  {
	uart_clrscr();
	uart_puts(txt_logo_atmel);
  }
  return state_uart_splash=TRUE;
}
#endif

/*F**************************************************************************
* O: uart_gotoxy
*----------------------------------------------------------------------------
* Ұ:
*		x: ِʒu(sʒu) (ˉE)
*		y: ِʒu(sʒu) (ˉ)
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* zِΈړ: putcharx,yʒuɕu܂B
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
* x=0͍s̐擪
*----------------------------------------------------------------------------
* Kv:
* x=0̏ꍇAVT100݊
*****************************************************************************/
void uart_gotoxy (Byte x, Byte y)
{
  if (!x)
  {
	uart_putchar('\r');
	uart_putchar('\n');
  }
  else
  {
  #ifndef DISABLE_VT100
	uart_putchar(27);
	uart_putchar(0x5B);
	if (y>9) uart_putchar('0'+(y/10));
	uart_putchar('0'+(y%10));
	uart_putchar(';');
	if (x>9) uart_putchar('0'+(x/10));
	uart_putchar('0'+(x%10));
	uart_putchar('H');
  #else
	uart_putchar('\r');
	for (;y--;) uart_putchar('\n');
	x--; // 0,1 => no space
	for (;x--;) uart_putchar(' ');
  #endif
  }
}
#endif // UART_MINIMUM

/*F**************************************************************************
* O: uart_test_hit
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* uart_hitϐXV: UARTŉMꂽ
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
bit uart_test_hit (void)
{
  return uart_hit=Uart_rx_ready();
}

/*F**************************************************************************
* O: uart_init
*----------------------------------------------------------------------------
* Ұ: Ȃ
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* wްڰĂUART
*****************************************************************************
* : ر ߰ē`: ްڰĂ8ޯ(7.37MHz9600bps)
*****************************************************************************/
bit uart_init (void)
{
  Uart_hw_init(UART_CONFIG);
  Uart_set_baudrate(BAUDRATE);
  Uart_enable();
  return TRUE;
}

/*F**************************************************************************
* O: uart_putchar
*----------------------------------------------------------------------------
* Ұ:
*		ch: UARTŏo͂镶
* ߂l: o͂ꂽ
*----------------------------------------------------------------------------
* ړI:
* UARTł̕o
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
char uart_putchar (char ch)
{
  while(!Uart_tx_ready());
  Uart_set_tx_busy();			// ()OɑZ׸ނݒ
  Uart_send_byte(ch);
  return ch;
}

/*F**************************************************************************
* O: uart_getchar
*----------------------------------------------------------------------------
* Ұ:
* ߂l: UARTœǂ܂ꂽ
*----------------------------------------------------------------------------
* ړI:
* UART當擾
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
char uart_getchar (void)
{
  register char c;

  while(!Uart_rx_ready());
  c = Uart_get_byte();
  Uart_ack_rx_byte();
  return c; 
}
